/*
   kopkop - stealthy secure remote event triggering for ip networks

   Copyright (C) 2004 Erno Rigo <mcree@tricon.hu>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define _GNU_SOURCE

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include "init.h"
#include "kopkopd.h"
#include "kopkop.h"
#include "twofish.h"
#include "config.h"

#include "glob.inc"

int main(int argc, char *argv[])
{
     if (init(argc, argv) == EXIT_FAILURE) {
	  fprintf(stderr,"init() failed: bailing out");
	  return EXIT_FAILURE;
     }

//     printf("%s\n",config.listenInterface);

     if (config.getVersionInfo) {
	  printf(PACKAGE" "VERSION"\n");
	  return EXIT_SUCCESS;
     }

     if (config.daemonMode) {	  
	  if(!config.verbose) {
	       daemon(0,0);
	  }
	  kopkopd();
     } else if (config.targetIP && config.command) {
	  kopkop();
     } else {
	  fprintf(stderr,"You must specify -d or -c and the target ip. Use --help\n");
	  return EXIT_FAILURE;
     }

     closelog();

     return EXIT_SUCCESS;
}
