/*
   kopkop - stealthy secure remote event triggering for ip networks

   Copyright (C) 2004 Erno Rigo <mcree@tricon.hu>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#define _GNU_SOURCE
#include "mwcrand.h"
#include <stdlib.h>
#include <stdio.h>

/* concatenation of following two 16-bit multiply with carry generators */
/* x(n)=a*x(n-1)+carry mod 2^16 and y(n)=b*y(n-1)+carry mod 2^16, */
/* number and carry packed within the same 32 bit integer.        */
/******************************************************************/

//unsigned int mwc_rand(void);	/* returns a mwc_random 32-bit integer */
//void mwc_rand_seed(unsigned int, unsigned int);	/* seed the generator */

/* return a mwc_random float >= 0 and < 1 */
#define mwc_rand_float          ((double)mwc_rand() / 4294967296.0)

//static unsigned int SEED_X = 521288629;
//static unsigned int SEED_Y = 362436069;

unsigned int mwc_rand(mwc_rand_env_t *env)
{
/* Use any pair of non-equal numbers from this list for "a" and "b"
    18000 18030 18273 18513 18879 19074 19098 19164 19215 19584       
    19599 19950 20088 20508 20544 20664 20814 20970 21153 21243       
    21423 21723 21954 22125 22188 22293 22860 22938 22965 22974       
    23109 23124 23163 23208 23508 23520 23553 23658 23865 24114       
    24219 24660 24699 24864 24948 25023 25308 25443 26004 26088       
    26154 26550 26679 26838 27183 27258 27753 27795 27810 27834       
    27960 28320 28380 28689 28710 28794 28854 28959 28980 29013       
    29379 29889 30135 30345 30459 30714 30903 30963 31059 31083
*/
    static unsigned int a = 18000, b = 30903;

    env->SEED_X = a * (env->SEED_X & 65535) + (env->SEED_X >> 16);
    env->SEED_Y = b * (env->SEED_Y & 65535) + (env->SEED_Y >> 16);

    return ((env->SEED_X << 16) + (env->SEED_Y & 65535));
}


void mwc_rand_seed(mwc_rand_env_t *env, unsigned int seed1, unsigned int seed2)
{
    if (seed1)
	env->SEED_X = seed1;		/* use default seeds if parameter is 0 */
    if (seed2)
	env->SEED_Y = seed2;
}
